"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "include", {
  enumerable: true,
  get: function () {
    return _core.include;
  }
});
Object.defineProperty(exports, "raw", {
  enumerable: true,
  get: function () {
    return _core.raw;
  }
});
exports.pwsh = exports.powershell = void 0;

var _os = _interopRequireDefault(require("os"));

var _core = require("@script-string/core");

var _language = _interopRequireDefault(require("./language"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const runner = {
  useStdIn: true,
  extension: '.ps1',
  command: {
    bin: _os.default.platform() === 'win32' ? 'powershell.exe' : 'pwsh',
    common: ['-NoProfile'],
    stdin: ['-Command', '-'],
    file: ['-File']
  }
};
const params = [['args', 'ScriptArguments', []]];
const args = 'ScriptArguments';

class PSScript extends _core.Builder {
  constructor(strings, values, options) {
    super(strings, values, {
      name: 'powershell',
      language: _language.default,
      runner,
      params,
      args,
      ...options
    });
  }

  *_foot() {
    // powershell -Command - needs the extra lines at the end to correctly
    // excute multi lines scripts
    yield '\n\n';
  }

}

const powershell = (0, _core.define)(['powershell', 'pwsh'], PSScript); // alias

exports.pwsh = exports.powershell = powershell;